# coding: utf-8

"""
    HRA-API

    This API provides programmatic access to data registered to the Human Reference Atlas (HRA). See the [HuBMAP HRA Portal](https://humanatlas.io/) for details.   # noqa: E501

    The version of the OpenAPI document: 1.2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ccf_openapi_client import schemas  # noqa: F401


class SpatialObjectReference(
    schemas.ComposedBase,
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A Spatial Object Reference provides a reference to an external representation of a Spatial Entity.
    """


    class MetaOapg:
        
        class properties:
            file = schemas.StrSchema
            file_format = schemas.StrSchema
            file_subpath = schemas.StrSchema
            __annotations__ = {
                "file": file,
                "file_format": file_format,
                "file_subpath": file_subpath,
            }
        additional_properties = schemas.AnyTypeSchema
        
        @classmethod
        @functools.lru_cache()
        def all_of(cls):
            # we need this here to make our import statements work
            # we must store _composed_schemas in here so the code is only run
            # when we invoke this method. If we kept this at the class
            # level we would get an error because the class level
            # code would be run when this module is imported, and these composed
            # classes don't exist yet because their module has not finished
            # loading
            return [
                JsonLdObject,
            ]

    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file"]) -> MetaOapg.properties.file: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file_format"]) -> MetaOapg.properties.file_format: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file_subpath"]) -> MetaOapg.properties.file_subpath: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> MetaOapg.additional_properties: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["file"], typing_extensions.Literal["file_format"], typing_extensions.Literal["file_subpath"], str, ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file"]) -> typing.Union[MetaOapg.properties.file, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file_format"]) -> typing.Union[MetaOapg.properties.file_format, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file_subpath"]) -> typing.Union[MetaOapg.properties.file_subpath, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[MetaOapg.additional_properties, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["file"], typing_extensions.Literal["file_format"], typing_extensions.Literal["file_subpath"], str, ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        file: typing.Union[MetaOapg.properties.file, str, schemas.Unset] = schemas.unset,
        file_format: typing.Union[MetaOapg.properties.file_format, str, schemas.Unset] = schemas.unset,
        file_subpath: typing.Union[MetaOapg.properties.file_subpath, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[MetaOapg.additional_properties, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
    ) -> 'SpatialObjectReference':
        return super().__new__(
            cls,
            *_args,
            file=file,
            file_format=file_format,
            file_subpath=file_subpath,
            _configuration=_configuration,
            **kwargs,
        )

from ccf_openapi_client.model.json_ld_object import JsonLdObject
