# coding: utf-8

"""
    HRA-API

    This API provides programmatic access to data registered to the Human Reference Atlas (HRA). See the [HuBMAP HRA Portal](https://humanatlas.io/) for details.   # noqa: E501

    The version of the OpenAPI document: 1.2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ccf_openapi_client import schemas  # noqa: F401


class SpatialPlacementScaling(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    The properties to define the Scaling aspect of Spatial Placements.
    """


    class MetaOapg:
        required = {
            "scaling_units",
            "x_scaling",
            "z_rotation",
            "y_scaling",
        }
        
        class properties:
            x_scaling = schemas.NumberSchema
            y_scaling = schemas.NumberSchema
            scaling_units = schemas.StrSchema
            z_scaling = schemas.NumberSchema
            __annotations__ = {
                "x_scaling": x_scaling,
                "y_scaling": y_scaling,
                "scaling_units": scaling_units,
                "z_scaling": z_scaling,
            }
    
    scaling_units: MetaOapg.properties.scaling_units
    x_scaling: MetaOapg.properties.x_scaling
    z_rotation: schemas.AnyTypeSchema
    y_scaling: MetaOapg.properties.y_scaling
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["x_scaling"]) -> MetaOapg.properties.x_scaling: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["y_scaling"]) -> MetaOapg.properties.y_scaling: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["scaling_units"]) -> MetaOapg.properties.scaling_units: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["z_scaling"]) -> MetaOapg.properties.z_scaling: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["x_scaling", "y_scaling", "scaling_units", "z_scaling", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["x_scaling"]) -> MetaOapg.properties.x_scaling: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["y_scaling"]) -> MetaOapg.properties.y_scaling: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["scaling_units"]) -> MetaOapg.properties.scaling_units: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["z_scaling"]) -> typing.Union[MetaOapg.properties.z_scaling, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["x_scaling", "y_scaling", "scaling_units", "z_scaling", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        scaling_units: typing.Union[MetaOapg.properties.scaling_units, str, ],
        x_scaling: typing.Union[MetaOapg.properties.x_scaling, decimal.Decimal, int, float, ],
        z_rotation: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        y_scaling: typing.Union[MetaOapg.properties.y_scaling, decimal.Decimal, int, float, ],
        z_scaling: typing.Union[MetaOapg.properties.z_scaling, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SpatialPlacementScaling':
        return super().__new__(
            cls,
            *_args,
            scaling_units=scaling_units,
            x_scaling=x_scaling,
            z_rotation=z_rotation,
            y_scaling=y_scaling,
            z_scaling=z_scaling,
            _configuration=_configuration,
            **kwargs,
        )
