# coding: utf-8

"""
    HRA-API

    This API provides programmatic access to data registered to the Human Reference Atlas (HRA). See the [HuBMAP HRA Portal](https://humanatlas.io/) for details.   # noqa: E501

    The version of the OpenAPI document: 1.2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ccf_openapi_client import schemas  # noqa: F401


class TissueSection(
    schemas.ComposedBase,
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A single section sample.
    """


    class MetaOapg:
        required = {
            "sampleType",
        }
        
        class properties:
            sampleType = schemas.StrSchema
            
            
            class sectionNumber(
                schemas.IntSchema
            ):
            
            
                class MetaOapg:
                    inclusive_minimum = 0
            __annotations__ = {
                "sampleType": sampleType,
                "sectionNumber": sectionNumber,
            }
        additional_properties = schemas.AnyTypeSchema
        
        @classmethod
        @functools.lru_cache()
        def all_of(cls):
            # we need this here to make our import statements work
            # we must store _composed_schemas in here so the code is only run
            # when we invoke this method. If we kept this at the class
            # level we would get an error because the class level
            # code would be run when this module is imported, and these composed
            # classes don't exist yet because their module has not finished
            # loading
            return [
                JsonLdObject,
                TissueCommon,
                TissueSampleCommon,
            ]

    
    sampleType: MetaOapg.properties.sampleType
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sampleType"]) -> MetaOapg.properties.sampleType: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sectionNumber"]) -> MetaOapg.properties.sectionNumber: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> MetaOapg.additional_properties: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["sampleType"], typing_extensions.Literal["sectionNumber"], str, ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sampleType"]) -> MetaOapg.properties.sampleType: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sectionNumber"]) -> typing.Union[MetaOapg.properties.sectionNumber, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[MetaOapg.additional_properties, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["sampleType"], typing_extensions.Literal["sectionNumber"], str, ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        sampleType: typing.Union[MetaOapg.properties.sampleType, str, ],
        sectionNumber: typing.Union[MetaOapg.properties.sectionNumber, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[MetaOapg.additional_properties, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
    ) -> 'TissueSection':
        return super().__new__(
            cls,
            *_args,
            sampleType=sampleType,
            sectionNumber=sectionNumber,
            _configuration=_configuration,
            **kwargs,
        )

from ccf_openapi_client.model.json_ld_object import JsonLdObject
from ccf_openapi_client.model.tissue_common import TissueCommon
from ccf_openapi_client.model.tissue_sample_common import TissueSampleCommon
